#ifndef __SGV_MESSAGE__
#define __SGV_MESSAGE__

#include "SgvSocket.h"
#include <vector>
#include <map>
#include <string>

namespace sigverse
{
	class RecvMsgEvent
	{
	private:
		std::string   m_from;
		std::string   m_msg;
	public:
		bool  setData(std::string data, int size);

		//! MG[WFg擾                                                                
		const char *getSender() { return m_from.c_str(); }

		//! iԖڂ̎̕擾                                                                           
		const char *getMsg() { return m_msg.c_str(); }
	};

	class SIGService
	{
	public:
		SIGService(std::string name);
		SIGService();
		~SIGService();

		//! bZ[WM 
		bool sendMsg(std::string to, std::string msg);

		//! T[oGeBeBRg[ɃbZ[W𒼐ڑM
		//! T[rXɐڑς݂̃GeBeBɂ̂ݑM
		bool sendMsgToCtr(std::string to, std::string msg);

		//! bZ[WM(肪) 
		bool sendMsg(std::vector<std::string> to, std::string msg);

		//! T[oɐڑ
		bool connect(std::string host, int port);

		//! T[oƐؒf
		bool disconnect();

		//! Rg[Ƃ̐ڑؒf(GeBeBw)
		bool disconnectFromController(std::string entityName);

		//! Rg[Ƃ̐ڑؒf(GeBeBw)
		void disconnectFromAllController();

		//! f[^M[vJn(bZ[WMRg[̐ڑNGXgJnj
		void startLoop();

		//! f[^MMĂ邩ǂ`FbN(}CNb)
		bool checkRecvData(int usec);

		//! r[[ɐڑ
		bool connectToView();

		//! ̃T[rX擾
		std::string getName() { return m_name; }

		//! ̃T[rXݒ肷
		void setName(std::string name) { m_name = name; }

		//! قɐVT[oɐڑꂽT[rX̐擾
		int getNewServiceNum() { return (int)m_elseServices.size() ; }

		//! ڑĂGeBeB̖O擾
		std::vector<std::string> getAllConnectedEntitiesName() {
			return m_entitiesName;
		}

		//! T[oɐڑĂ鑼̃T[rX擾(x擾ƊJ)
		std::string getElseServiceName() {
			int size = (int)m_elseServices.size(); 
			std::string name = m_elseServices[size - 1];
			m_elseServices.pop_back();
			return name;
		}

		//! T[oɐڑĂ鑼̃T[rXǉ
		void setElseServiceName(std::string name) {
			m_elseServices.push_back(name);
		}

		SgvSocket* getSgvSocket(){
			return m_sgvsock;
		}

		//! Rg[SgvSocket擾
		SgvSocket* getControllerSocket(std::string name){
			std::map<std::string, sigverse::SgvSocket*>::iterator it;
			it = m_consocks.find(name);
			// SgvSocket
			if(it != m_consocks.end())
				return (*it).second;
			// SgvSocketȂ
			else
				return NULL;
		}

		int getConnectedControllerNum() {
			return (int)m_consocks.size();
		}

		//! bZ[WMCxgnh
		virtual void onRecvMsg(RecvMsgEvent &evt) {}

		//! IɌĂяo
		virtual double onAction() { return 0.0;}

	private:

	protected:
		//! socket(for server)
		sigverse::SgvSocket *m_sgvsock;

		//! socket(for viewer)
		sigverse::SgvSocket *m_viewsock;

		//! GeBeB̖OƃRg[p\Pbg̑Ή
		std::map<std::string, SgvSocket*> m_consocks;

		//! ڑ̑SGeBeB
		std::vector<std::string> m_entitiesName;

		//! name
		std::string m_name;

		//! ̃T[rX̖O
		std::vector<std::string> m_elseServices;

		//! ڑT[ozXg
		std::string m_host;

		//!T[rXX^[gĂ邩ǂ
		bool m_start;

		//!Rg[ڑ
		bool m_connected;
	};
}

#endif
